/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.aggregates.aggregation;

import com.macrofocus.molap.aggregates.cube.Group;
import com.macrofocus.molap.aggregates.cuboid.Cuboid;
import com.macrofocus.molap.series.Series;

public class CountAggregation extends AbstractAggregation {
    private final Series column;

    public CountAggregation(Series column) {
        this.column = column;
    }

    @Override
    public Class getType() {
        return Long.class;
    }

    @Override
    public Object compute(Cuboid cuboid, Group group) {
        return cuboid.getDistributiveStatistics(group, column).getCount();
    }

    @Override
    public String toString() {
        return "Count(" + column.getName() + ")";
    }
}
