/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.aggregates.aggregation;

import com.macrofocus.molap.aggregates.cube.Group;
import com.macrofocus.molap.aggregates.cuboid.Cuboid;
import com.macrofocus.molap.series.Series;

import java.util.Set;

public class CountDistinctAggregation extends AbstractAggregation {
    private final Series column;

    public CountDistinctAggregation(Series column) {
        this.column = column;
    }

    @Override
    public Class getType() {
        return Integer.class;
    }

    @Override
    public Object compute(Cuboid cuboid, Group group) {
        final Set<Object> distinct = cuboid.getDistinct(group, column);
        if(distinct != null) {
            return distinct.contains(null) ? distinct.size() - 1 : distinct.size();
        } else {
            return null;
        }
    }

    @Override
    public String toString() {
        return "CountDistinct(" + column.getName() + ")";
    }
}
