/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.aggregates.aggregation;

import com.macrofocus.molap.aggregates.cube.DistributiveStatistics;
import com.macrofocus.molap.aggregates.cube.Group;
import com.macrofocus.molap.aggregates.cuboid.Cuboid;
import com.macrofocus.molap.series.Series;

public class MaxAggregation extends AbstractAggregation {
    private final Series column;

    public MaxAggregation(Series column) {
        this.column = column;
    }

    @Override
    public Class getType() {
        return Number.class;
    }

    @Override
    public Object compute(Cuboid cuboid, Group group) {
        final DistributiveStatistics distributiveStatistics = cuboid.getDistributiveStatistics(group, column);
        return distributiveStatistics.getMaximum();
    }

    public Number getValue() {
        DistributiveStatistics distributiveStatistics = new DistributiveStatistics(column);
        return distributiveStatistics.getMaximum();
    }

    @Override
    public String toString() {
        return "Max(" + column.getName() + ")";
    }
}
