/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.aggregates.aggregation;

import com.macrofocus.molap.aggregates.cube.DistributiveStatistics;
import com.macrofocus.molap.aggregates.cube.Group;
import com.macrofocus.molap.aggregates.cuboid.Cuboid;
import com.macrofocus.molap.series.Series;

public class SumAggregation extends AbstractAggregation {
    private final Series column;

    public SumAggregation(Series column) {
        this.column = column;
    }

    @Override
    public Class getType() {
        return Double.class;
    }

    @Override
    public Object compute(Cuboid cuboid, Group group) {
        final DistributiveStatistics distributiveStatistics = cuboid.getDistributiveStatistics(group, column);
        if(distributiveStatistics != null) {
            return distributiveStatistics.getSum();
        } else {
            return null;
        }
    }

    @Override
    public String toString() {
        return "Sum(" + column.getName() + ")";
    }
}
