/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.aggregates.cuboid;

import com.macrofocus.molap.aggregates.cube.Cube;
import com.macrofocus.molap.aggregates.cube.Dimensions;
import com.macrofocus.molap.aggregates.cube.DistributiveStatistics;
import com.macrofocus.molap.aggregates.cube.Group;
import com.macrofocus.molap.series.Series;

import java.util.Set;

/**
 *
 */
public interface Cuboid {
    Object ALL = new Object() {
        @Override
        public String toString() {
            return "(all)";
        }
    };

    public Cube getCube();

    public Dimensions getDimensions();

    public Iterable<Group> getGroups();

    Iterable<Group> getGroupsStartingWith(Group group);

    int getGroupsStartingWithCount(Group group);

    public int getGroupsCount();

    public Set<Object> getValues();

    DistributiveStatistics getDistributiveStatistics(Group group, Series columm);

    Set<Object> getDistinct(Group group, Series columm);

    public Iterable<Object> getRows(Group group);

    /**
     * Add one level to the group by.
     *
     * @param columns the levels to add
     * @return
     */
    public Cuboid drillDown(Object... columns);

    /**
     * Remove the last level from the group by.
     *
     * @return
     */
    public Cuboid drillUp();

    /**
     * Filter on a single single values.
     *
     * @param value
     * @return
     */
    public Cuboid slice(Object value);

    /**
     * Filter on multiple values.
     *
     * @param valuesSets
     * @return
     */
    public Cuboid dice(Set<Object> valuesSets);

    public Cuboid collapse();
}
