/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.dataframe;

import com.macrofocus.helper.TableHelper;
import com.macrofocus.molap.series.Series;

import java.util.Date;

@Deprecated
public class DataFrameHelper {
    @Deprecated
    public static <R,C> TableHelper.ColumnStatistics getColumnStatistics(DataFrame<R,C,?> dataFrame, C column) {
        Number min = null;
        Number max = null;
        double sum = 0;
        long count = 0;
        Series series = dataFrame.getColumn(column);
        for (R row: dataFrame.rows()) {
            Object value = series.get(row);
            if (value != null) {
                if (value instanceof Number) {
                    Number number = (Number) value;
                    double d = number.doubleValue();

                    if (number instanceof Double) {
                        if (!Double.isNaN(d) && !Double.isInfinite(d)) {
                            if (min == null || d < min.doubleValue()) {
                                min = number;
                            }

                            if (max == null || d > max.doubleValue()) {
                                max = number;
                            }

                            sum += number.doubleValue();
                            count++;
                        }
                    } else if (number instanceof Float) {
                        float f = number.floatValue();
                        if (!Float.isNaN(f) && !Float.isInfinite(f)) {
                            if (min == null || d < min.doubleValue()) {
                                min = number;
                            }

                            if (max == null || d > max.doubleValue()) {
                                max = number;
                            }
                        }
                    } else {
                        if (min == null || d < min.doubleValue()) {
                            min = number;
                        }

                        if (max == null || d > max.doubleValue()) {
                            max = number;
                        }

                        sum += d;
                        count++;
                    }
                } else if (value instanceof Date) {
                    Date date = (Date) value;
                    final long time = date.getTime();
                    if (min == null || time < min.doubleValue()) {
                        min = time;
                    }

                    if (max == null || time > max.doubleValue()) {
                        max = time;
                    }

                    sum += time;
                    count++;
                }
            }
        }

        return new TableHelper.ColumnStatistics(min, max, sum, count);
    }
}
