/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.dataframe;

/**
 * The listener interface for receiving "interesting" events about a selection.
 *
 * @param <R> the type of row keys
 * @param <C> the type of column keys
 */
public interface DataFrameListener<R,C> {
    /**
     * Called whenever the structure or the values of the data frame changes.
     *
     * @param event the event that characterizes the change.
     */
    void dataFrameChanged(DataFrameEvent<R,C> event);
}
