/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.dataframe;

/**
 * Defines the requirements for a data frame that can change.
 */
public interface MutableDataFrame<R,C,V> extends DataFrame<R,C,V> {
    /**
     * Sets the value for the cell at the intersection of the
     * <code>column</code> key and <code>row</code> key.
     *
     * @param   row        the row key whose value is to be changed
     * @param   column     the column key whose value is to be changed
     * @param value the new value at the specified cell
     */
    void setValueAt(R row, C column, V value);
}
