/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.dataframe.swing;

import com.macrofocus.molap.dataframe.DataFrame;

import javax.swing.*;

public class ColumnsComboBoxModel extends DefaultComboBoxModel {
    public <C> ColumnsComboBoxModel(DataFrame<?,C,?> dataFrame, boolean onlyNumerical, boolean includeNull) {
        if (includeNull) {
            addElement(null);
        }
        for (C c: dataFrame.columns()) {
            if (!onlyNumerical || Number.class.isAssignableFrom(dataFrame.getColumnClass(c))) {
                addElement(c);
            }
        }
    }
}
