/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.dataframe.swing;

import com.macrofocus.molap.dataframe.DataFrame;
import com.macrofocus.molap.dataframe.DataFrameFactory;
import com.macrofocus.molap.dataframe.DefaultDataFrame;

import javax.swing.table.TableModel;

/**
 * Factory for supporting the most common ways of instantiating <code>DataFrame</code> object from Swing models.
 */
public class SwingDataFrameFactory extends DataFrameFactory {
    /**
     * Creates a data frame using a Swing TableModel.
     *
     * @param tableModel the table model
     * @param <V> the type of values
     * @return a newly created data frame.
     */
    public static <V> DataFrame<Integer,String,V> fromTableModel(TableModel tableModel) {
        return new DefaultDataFrame<V>(tableModel);
    }
}
