/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.index;

public interface Index<K> {
    public Integer getAddress(K key);

    public Index<K> head(int count);

    public Index<K> tail(int count);

    Index<K> union(Index<K> other);

    Index<K> intersection(Index<K> other);

    public Iterable<K> keys();

    boolean contains(K key);

    public K getKey(int i);

    public int getSize();
}
