/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.series;

import com.macrofocus.molap.index.Index;

public class ReIndexedSeries<K,V,X> extends AbstractSeries<K,V> {
    private Index<K> index;

    private final ReIndexRecipe<K> recipe;
    private final Series<X,V> series;

    public ReIndexedSeries(Series<X, V> series, ReIndexRecipe<K> recipe) {
        this.series = series;
        this.recipe = recipe;
    }

    @Override
    public Object getName() {
        return series.getName();
    }

    @Override
    public Class getType() {
        return series.getType();
    }

    @Override
    public V get(K key) {
        final Integer address = getIndex().getAddress(key);
        if(address != null) {
            final X x = series.getKey(address);
            return series.get(x);
        } else {
            return null;
        }
    }

    @Override
    public K getKey(int index) {
        return getIndex().getKey(index);
    }

    @Override
    public Iterable<K> keys() {
        return getIndex().keys();
    }

    @Override
    public <L> Series<L, V> reindex(L... keys) {
        return null;
    }

    @Override
    public Series<K, V> head(int count) {
        return null;
    }

    @Override
    public Series<K, V> tail(int count) {
        return null;
    }

    private Index<K> getIndex() {
        if(index == null) {
            index = recipe.buildIndex();
        }
        return index;
    }

    public interface ReIndexRecipe<K> {
        Index<K> buildIndex();

    }
}
