/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.series;

public interface Series<K,V> {
    Object getName();

    Class getType();

    V get(K key);

    K getKey(int i);

    public Iterable<K> keys();

    <L> Series<L,V> reindex(L... keys);

    Integer count();

    Double sum();

    Double mean();

    Double meanAbsoluteDeviation();

    V median();

    V min();

    V max();

    Integer countUnique();

    K indexMin();

    K indexMax();

    Series<K, V> head(int count);

    Series<K, V> tail(int count);

    Series<K,Double> add(Series<K,V> other);

    Series<K,Double> subtract(Series<K,V> other);

    Series<K,Double> multiply(Series<K,V> other);

    Series<K,Double> divide(Series<K,V> other);

    Series<K,Double> pow(Double exponent);

    void print();
}
