/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.series;

public class SeriesFactory {
    private static final SeriesFactory ourInstance = new SeriesFactory();

    public static SeriesFactory getInstance() {
        return ourInstance;
    }

    private SeriesFactory() {
    }

    public static <V> MutableSeries<Integer,V> create(V... values) {
        return getInstance().build(values);
    }

    public static <V> MutableSeries<Integer,V> create(Object name, V... values) {
        return getInstance().build(name, values);
    }

    public static <K,V> Series<K,V> create(Object name, V[] values, K[] keys) {
        return getInstance().build(name, values, keys);
    }

    private <V> MutableSeries<Integer,V> build(V... values) {
        return new DefaultSeries<V>(values);
    }

    private <V> MutableSeries<Integer,V> build(Object name, V[] values) {
        return new DefaultSeries<V>(name, values);
    }

    private <K,V> Series<K,V> build(Object name, V[] values, K[] keys) {
        return new IndexedSeries<K,V>(name, values, keys);
    }
}
