/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.table;

import java.util.Arrays;

public class Columns {
    private final Column[] columns;

    public Columns(Column... columns) {
        this.columns = columns;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Columns)) return false;

        Columns columns1 = (Columns) o;

        if (!Arrays.equals(columns, columns1.columns)) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return columns != null ? Arrays.hashCode(columns) : 0;
    }

    public ColumnsValue getValue(int r) {
        Object[] array = new Object[columns.length];
        for (int i = 0; i < columns.length; i++) {
            Column column = columns[i];
            array[i] = column.getValueAt(r);
        }
        return new ColumnsValue(array);
    }

    public int getRowCount() {
        return columns[0].getRowCount();
    }

    public Row getRow(int r) {
        return columns[0].getRow(r);
    }
}
