/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */
package com.macrofocus.molap.table;

import java.util.Arrays;

public class ColumnsValue {
    private final Object[] values;

    public ColumnsValue(Object... values) {
        this.values = values;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof ColumnsValue)) return false;

        ColumnsValue columns1 = (ColumnsValue) o;

        return Arrays.equals(values, columns1.values);

    }

    @Override
    public int hashCode() {
        return values != null ? Arrays.hashCode(values) : 0;
    }

    @Override
    public String toString() {
        return "ColumnsValue{" +
                "values=" + Arrays.toString(values) +
                '}';
    }
}
