/*
 * Copyright (c) 2014 Macrofocus GmbH. All Rights Reserved.
 */

import com.macrofocus.molap.aggregates.AggregateDataFrame;
import com.macrofocus.molap.aggregates.aggregation.Aggregation;
import com.macrofocus.molap.dataframe.DataFrame;
import com.macrofocus.molap.dataframe.DataFrameFactory;

import java.io.IOException;

public class Superstore {
    public static void main(String[] args) {
        try {
            DataFrame<Integer,String,?> dataFrame = DataFrameFactory.fromExcel(Superstore.class.getResource("Sample - Superstore Sales (Excel).xls"));

            final Aggregation profit = dataFrame.getSum("Profit").as("Profit");
            AggregateDataFrame<String> aggregateDataFrame = dataFrame.aggregate(
                    dataFrame.getSum("Order Quantity").as("Quantity"),
                    dataFrame.getSum("Sales").as("Revenue"),
                    profit
            );

            aggregateDataFrame = aggregateDataFrame
                    .drillDown("Product Category", "Product Sub-Category")
                    .order(profit)
            ;

            aggregateDataFrame.print();

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
