import com.macrofocus.molap.aggregates.aggregation.Aggregation;
import com.macrofocus.molap.aggregates.cube.Cube;
import com.macrofocus.molap.aggregates.cube.InMemoryCube;
import com.macrofocus.molap.aggregates.query.Query;
import com.macrofocus.molap.dataframe.DataFrame;
import com.macrofocus.molap.dataframe.DataFrameFactory;

import java.io.IOException;
import java.sql.SQLException;

public class Ensembl {
    public static void main(String[] args) {
        try {
            DataFrame dataFrame = DataFrameFactory.fromMySQL("jdbc:mysql://ensembldb.ensembl.org:5306/ensembl_go_54", "anonymous", null,
                  " SELECT\n" +
                          "  s.*\n" +
                          " FROM\n" +
                          "  species AS s,\n" +
                          "  species AS t\n" +
                          " WHERE\n" +
                          "  (s.left_value BETWEEN t.left_value AND t.right_value) AND\n" +
                          "  t.common_name='mammals';"
            );

            Cube cube = new InMemoryCube(dataFrame);

            Aggregation count = cube.getCount("id").as("Count");

            Query query = cube.query(count).drillDown("genus").order(count);
            query.printResults(System.out, "", false);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

}
